from datetime import datetime
import time
import random
import string

def format_datetime(dt):
    return dt.strftime('%Y-%m-%d %H:%M:%S')
    
def format_compact_datetime(dt):
    return dt.strftime('%Y%m%d%H%M%S')

def format_date(dt):
    return dt.strftime('%Y-%m-%d')

def format_sql_datetime(dt):
    return str(dt) if isinstance(dt, datetime) else dt

def format_time_ms(float_time):
    local_time = time.localtime(float_time)
    data_head = time.strftime("%Y-%m-%d %H:%M:%S", local_time)
    data_secs = (float_time - int(float_time)) * 1000
    return "%s.%03d" % (data_head, data_secs)

def str_to_datetime(str_time):
    return datetime.strptime(str_time.split('.')[0], '%Y-%m-%d %H:%M:%S')

def rand_str(str_len = 4):
    letters = string.digits
    result_str = ''.join(random.choice(letters) for i in range(str_len))
    return result_str

def rand_time_str(postfix_str_len = 4):
    return format_compact_datetime(datetime.now()) + rand_str(postfix_str_len)